#/usr/bin/perl

# Resize file with netPBM package

if ($#ARGV<4)
{
	print "Format: resize.pl src.jpg target.jpg <quality> <width> <height>\n";
	exit(1);
}

# Set path to your netpbm package here (terminated with /)
my $netpbm_path="";

my $file_in=@ARGV[0];
my $file_out=@ARGV[1];
my $quality=@ARGV[2];
my $width=@ARGV[3];
my $height=@ARGV[4];

my $fmt2pbm;
my $pbm2fmt;

if ($file_in =~ /\.(jpg|jpeg)$/i)
{
	$fmt2pnm="jpegtopnm";
}
elsif ($file_in =~ /\.png$/i)
{
	$fmt2pnm="pngtopnm";
}
elsif ($file_in =~ /\.gif$/i)
{
	$fmt2pnm="giftopnm";
}
else
{
	print "Invalid input file extension.\n";
	exit(1);
}

if ($file_out =~ /\.(jpg|jpeg)$/i)
{
	$pnm2fmt="pnmtojpeg";
	$quality=" --quality=$quality ";
}
elsif ($file_out =~ /\.png$/i)
{
	$pnm2fmt="pnmtopng";
	$quality="";
}
elsif ($file_out =~ /\.gif$/i)
{
	$pnm2fmt="pnmtogif";
	$quality="";
}
else
{
	print "Invalid output file extension.\n";
	exit(1);
}

# Compose command line
my $cmdLine;

# Convert source file to PNM
$cmdLine=  "${netpbm_path}$fmt2pnm \"$file_in\" | ";

# Do something with the PNM
$cmdLine.= "${netpbm_path}pnmscale -xysize $width $height | ";

# Convert PNM back to the source file format
$cmdLine.= "${netpbm_path}$pnm2fmt $quality >\"$file_out\"";

exec($cmdLine);

exit(0);
